// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

template <typename Key, typename Elem>
class TTNode {       // 2-3 tree node structure
public:
  Elem lval;         // The node's left record
  Key lkey;          // Left record's key
  Elem rval;         // The node's right record
  Key rkey;          // Right record's key
  TTNode* left;      // Pointer to left child
  TTNode* center;    // Pointer to middle child
  TTNode* right;     // Pointer to right child
  TTNode()
   { center = left = right = NULL; lkey = rkey = EMPTYKEY; }
  ~TTNode() { }
  bool isLeaf() { return left == NULL; }
};
